diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
index eb2a0240a..6a45dccf3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -14,6 +16,7 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -71,6 +74,11 @@ public class BlockLogicAlgae extends BlockLogic implements IBonemealable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 3c9cfc584..e56c2b5be 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -3,6 +3,9 @@ import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityBasket;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -12,6 +15,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicBasket extends BlockLogic
 {
@@ -51,6 +55,11 @@ public class BlockLogicBasket extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side == Side.TOP ? PartialSupport.INSTANCE : FullSupport.INSTANCE;
+    }
+
     public int getFillLevel(final WorldSource world, final int x, final int y, final int z)
     {
         final TileEntityBasket te = (TileEntityBasket) world.getTileEntity(x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index e17a9fe17..dc8949cae 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -3,6 +3,8 @@ package net.minecraft.core.block;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
@@ -11,6 +13,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicBed extends BlockLogic {
 
@@ -89,6 +92,11 @@ public class BlockLogicBed extends BlockLogic {
 		return false;
 	}
 
+	@Override
+	public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+		return PartialSupport.INSTANCE;
+	}
+
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
 		removeOtherHalf(world, x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
index 1c85641e3..4cda18dd9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
@@ -3,6 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemFireStriker;
@@ -11,6 +14,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -37,6 +41,11 @@ public class BlockLogicBrazier
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side == Side.BOTTOM ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
         return new ItemStack[] { new ItemStack(Blocks.BRAZIER_INACTIVE, 1) };
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index bc595e9d9..4989e6847 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -2,6 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -19,7 +22,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicButton extends BlockLogic implements IPaintable
+public class BlockLogicButton extends BlockLogic implements IPaintable, ISupportable
 {
     public static final int MASK_POWERED = 0b0000_1000;
     public static final int MASK_DIRECTION = 0b0000_0111;
@@ -60,36 +63,26 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
         Side checkSide = side.getOpposite();
-        return world.isBlockNormalCube(x + checkSide.getOffsetX(), y + checkSide.getOffsetY(), z + checkSide.getOffsetZ());
+        return isSupported(world, x, y, z, checkSide);
     }
 
     @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
+    public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x, y - 1, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x, y + 1, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x - 1, y, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x + 1, y, z))
-        {
-            return true;
-        }
-        if(world.isBlockNormalCube(x, y, z - 1))
-        {
-            return true;
-        }
-        return world.isBlockNormalCube(x, y, z + 1);
+        return isSupported(world, x, y, z, Side.BOTTOM)
+            || isSupported(world, x, y, z, Side.TOP)
+            || isSupported(world, x, y, z, Side.NORTH)
+            || isSupported(world, x, y, z, Side.SOUTH)
+            || isSupported(world, x, y, z, Side.WEST)
+            || isSupported(world, x, y, z, Side.EAST);
     }
 
     @Override
@@ -97,32 +90,32 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         int orientation = -1;
         switch (side) {
             case BOTTOM:
-                if (world.isBlockNormalCube(x, y + 1, z)) {
+                if (isSupported(world, x, y, z, Side.TOP)) {
                     orientation = SIDE_TOP;
                 }
                 break;
             case TOP:
-                if (world.isBlockNormalCube(x, y - 1, z)) {
+                if (isSupported(world, x, y, z, Side.BOTTOM)) {
                     orientation = SIDE_BOTTOM;
                 }
                 break;
             case NORTH:
-                if (world.isBlockNormalCube(x, y, z + 1)) {
+                if (isSupported(world, x, y, z, Side.SOUTH)) {
                     orientation = SIDE_SOUTH;
                 }
                 break;
             case SOUTH:
-                if (world.isBlockNormalCube(x, y, z - 1)) {
+                if (isSupported(world, x, y, z, Side.NORTH)) {
                     orientation = SIDE_NORTH;
                 }
                 break;
             case WEST:
-                if (world.isBlockNormalCube(x + 1, y, z)) {
+                if (isSupported(world, x, y, z, Side.EAST)) {
                     orientation = SIDE_EAST;
                 }
                 break;
             case EAST:
-                if (world.isBlockNormalCube(x - 1, y, z)) {
+                if (isSupported(world, x, y, z, Side.WEST)) {
                     orientation = SIDE_WEST;
                 }
                 break;
@@ -130,8 +123,10 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         if (orientation == -1) {
             orientation = getOrientation(world, x, y, z);
         }
-        int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | orientation);
+        if (orientation != -1) {
+            int meta = world.getBlockMetadata(x, y, z);
+            world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | orientation);
+        }
     }
 
     @Override
@@ -140,32 +135,32 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         if (side.isHorizontal()) side = side.getOpposite();
         switch (side) {
             case BOTTOM:
-                if (world.isBlockNormalCube(x, y + 1, z)) {
+                if (isSupported(world, x, y, z, Side.TOP)) {
                     orientation = SIDE_TOP;
                 }
                 break;
             case TOP:
-                if (world.isBlockNormalCube(x, y - 1, z)) {
+                if (isSupported(world, x, y, z, Side.BOTTOM)) {
                     orientation = SIDE_BOTTOM;
                 }
                 break;
             case NORTH:
-                if (world.isBlockNormalCube(x, y, z + 1)) {
+                if (isSupported(world, x, y, z, Side.SOUTH)) {
                     orientation = SIDE_SOUTH;
                 }
                 break;
             case SOUTH:
-                if (world.isBlockNormalCube(x, y, z - 1)) {
+                if (isSupported(world, x, y, z, Side.NORTH)) {
                     orientation = SIDE_NORTH;
                 }
                 break;
             case WEST:
-                if (world.isBlockNormalCube(x + 1, y, z)) {
+                if (isSupported(world, x, y, z, Side.EAST)) {
                     orientation = SIDE_EAST;
                 }
                 break;
             case EAST:
-                if (world.isBlockNormalCube(x - 1, y, z)) {
+                if (isSupported(world, x, y, z, Side.WEST)) {
                     orientation = SIDE_WEST;
                 }
                 break;
@@ -173,34 +168,36 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         if (orientation == -1) {
             orientation = getOrientation(world, x, y, z);
         }
-        int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | orientation);
+        if (orientation != -1) {
+            int meta = world.getBlockMetadata(x, y, z);
+            world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | orientation);
+        }
     }
 
     private int getOrientation(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x - 1, y, z))
+        if(isSupported(world, x, y, z, Side.WEST))
         {
             return SIDE_WEST;
         }
-        if(world.isBlockNormalCube(x + 1, y, z))
+        if(isSupported(world, x, y, z, Side.EAST))
         {
             return SIDE_EAST;
         }
-        if(world.isBlockNormalCube(x, y, z - 1))
+        if(isSupported(world, x, y, z, Side.NORTH))
         {
             return SIDE_NORTH;
         }
-        if (world.isBlockNormalCube(x, y, z + 1)){
+        if (isSupported(world, x, y, z, Side.SOUTH)){
             return SIDE_SOUTH;
         }
-        if (world.isBlockNormalCube(x, y + 1, z)){
+        if (isSupported(world, x, y, z, Side.TOP)){
             return SIDE_TOP;
         }
-        if (world.isBlockNormalCube(x, y - 1, z)){
+        if (isSupported(world, x, y, z, Side.BOTTOM)){
             return SIDE_BOTTOM;
         }
-        return SIDE_WEST;
+        return -1;
     }
 
     @Override
@@ -211,22 +208,22 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         int side = meta & MASK_DIRECTION;
         switch (side) {
             case SIDE_WEST:
-                invalid = !world.isBlockNormalCube(x - 1, y, z);
+                invalid = !isSupported(world, x, y, z, Side.WEST);
                 break;
             case SIDE_EAST:
-                invalid = !world.isBlockNormalCube(x + 1, y, z);
+                invalid = !isSupported(world, x, y, z, Side.EAST);
                 break;
             case SIDE_NORTH:
-                invalid = !world.isBlockNormalCube(x, y, z - 1);
+                invalid = !isSupported(world, x, y, z, Side.NORTH);
                 break;
             case SIDE_SOUTH:
-                invalid = !world.isBlockNormalCube(x, y, z + 1);
+                invalid = !isSupported(world, x, y, z, Side.SOUTH);
                 break;
             case SIDE_TOP:
-                invalid = !world.isBlockNormalCube(x, y + 1, z);
+                invalid = !isSupported(world, x, y, z, Side.TOP);
                 break;
             case SIDE_BOTTOM:
-                invalid = !world.isBlockNormalCube(x, y - 1, z);
+                invalid = !isSupported(world, x, y, z, Side.BOTTOM);
                 break;
             default:
                 invalid = false;
@@ -393,7 +390,7 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isClientSide)
         {
@@ -447,4 +444,9 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
             world.scheduleBlockUpdate(x, y, z, Blocks.BUTTON_PLANKS_PAINTED.id(), tickDelay());
         }
     }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE.center();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 0a43f9201..db1cec00f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -1,5 +1,8 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -13,6 +16,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -33,7 +37,7 @@ public class BlockLogicCactus extends BlockLogic implements IBonemealable
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isAirBlock(x, y + 1, z))
         {
@@ -77,6 +81,11 @@ public class BlockLogicCactus extends BlockLogic implements IBonemealable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
+
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java
index 1670188c4..467a57983 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java
@@ -1,12 +1,16 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -37,6 +41,11 @@ public class BlockLogicCandle extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
index f79d6d8c3..1382198ff 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
@@ -1,14 +1,18 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicCobweb extends BlockLogic
 {
@@ -58,4 +62,9 @@ public class BlockLogicCobweb extends BlockLogic
     {
         return false;
     }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index 3be0632d0..83a7c18df 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -46,8 +46,8 @@ public class BlockLogicCropsPumpkin
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
-        super.updateTick(world, x, y, z, rand);
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         if (world.getBlockLightValue(x, y + 1, z) >= 9) {
             int meta = world.getBlockMetadata(x, y, z);
             if (meta < 6) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
index da7516505..bda59ab73 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
@@ -32,9 +32,9 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
-        super.updateTick(world, x, y, z, rand);
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         if(world.getBlockLightValue(x, y + 1, z) >= 9)
         {
             int l = world.getBlockMetadata(x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index 42e6dab32..da339ec45 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -116,7 +116,7 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         dispenseItem(world, x, y, z, rand);
     }
